--- old/usr/src/uts/common/os/semaphore.c	Wed Jul 25 03:02:28 2018
+++ new/usr/src/uts/common/os/semaphore.c	Wed Jul 25 03:02:28 2018
@@ -24,8 +24,6 @@
  * Use is subject to license terms.
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 /*
  * This file contains the semaphore operations.
  */
@@ -231,11 +229,11 @@
 	sqlp = &SQHASH(s)->sq_lock;
 	disp_lock_enter(sqlp);
 	ASSERT(s->s_count >= 0);
+	if (panicstr) {
+		disp_lock_exit(sqlp);
+		return;
+	}
 	while (s->s_count == 0) {
-		if (panicstr) {
-			disp_lock_exit(sqlp);
-			return;
-		}
 		thread_lock_high(curthread);
 		SEMA_BLOCK(s, sqlp);
 		thread_unlock_nopreempt(curthread);
@@ -376,6 +374,10 @@
 	s = (sema_impl_t *)sp;
 	sqh = SQHASH(s);
 	disp_lock_enter(&sqh->sq_lock);
+	if (panicstr) {
+		disp_lock_exit(sqlp);
+		return (1);
+	}
 	if (s->s_count > 0) {
 		s->s_count--;
 		gotit = 1;
